"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from investec_za_pb.types import BaseModel
import pydantic
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class BeneficiaryCategoriesDataTypedDict(TypedDict):
    r"""Set of elements used to define the beneficiaries category details."""

    id: NotRequired[str]
    r"""A unique and immutable identifier used to identify the beneficiary category resource. This identifier has no meaning to the account owner."""
    is_default: NotRequired[str]
    r"""A flag identifying the default category."""
    name: NotRequired[str]
    r"""The beneficiary category name."""


class BeneficiaryCategoriesData(BaseModel):
    r"""Set of elements used to define the beneficiaries category details."""

    id: Optional[str] = None
    r"""A unique and immutable identifier used to identify the beneficiary category resource. This identifier has no meaning to the account owner."""

    is_default: Annotated[Optional[str], pydantic.Field(alias="isDefault")] = None
    r"""A flag identifying the default category."""

    name: Optional[str] = None
    r"""The beneficiary category name."""


class BeneficiaryCategoriesMetaTypedDict(TypedDict):
    r"""Meta Data relevant to the payload"""

    total_pages: NotRequired[int]


class BeneficiaryCategoriesMeta(BaseModel):
    r"""Meta Data relevant to the payload"""

    total_pages: Annotated[Optional[int], pydantic.Field(alias="totalPages")] = None


class BeneficiaryCategoriesLinksTypedDict(TypedDict):
    r"""Links relevant to the payload"""

    self_: str


class BeneficiaryCategoriesLinks(BaseModel):
    r"""Links relevant to the payload"""

    self_: Annotated[str, pydantic.Field(alias="self")]


class BeneficiaryCategoriesResponseBodyTypedDict(TypedDict):
    r"""Resource has been retrieved"""

    data: BeneficiaryCategoriesDataTypedDict
    r"""Set of elements used to define the beneficiaries category details."""
    meta: BeneficiaryCategoriesMetaTypedDict
    r"""Meta Data relevant to the payload"""
    links: BeneficiaryCategoriesLinksTypedDict
    r"""Links relevant to the payload"""


class BeneficiaryCategoriesResponseBody(BaseModel):
    r"""Resource has been retrieved"""

    data: BeneficiaryCategoriesData
    r"""Set of elements used to define the beneficiaries category details."""

    meta: BeneficiaryCategoriesMeta
    r"""Meta Data relevant to the payload"""

    links: BeneficiaryCategoriesLinks
    r"""Links relevant to the payload"""
